(*$S15,T-,P-,R-,D-*)
Program Demo_Version;

CONST Pause1 = 25;

TYPE Muster    = Array [0..31] of Long_Integer;
     SpriteDat = Array [0..65] of Long_Integer;
     Clip      = Array [0..3] of Integer;

VAR  Pattern  : Array[0..5] of Muster;
     Sprite   : SpriteDat;
     Save     : SpriteDat;
     Clipping : Clip;
     dx,dy,x,y,
     i,k,ii   : Integer;
     handle   : Integer;
     s0,s     : String;
     b        : Boolean;

PROCEDURE FILLSCREEN(y0,y1,b:Integer;VAR Pattern:Muster);External;
PROCEDURE EFFECTFILL(y0,y1,b:Integer;VAR Pattern:Muster);External;
FUNCTION  READ_MUSTER(handle:Integer;laenge:Long_Integer;VAR Pattern:Muster):
          Long_Integer;GEMDOS($3F);
FUNCTION  READ_SPRITE(handle:Integer;laenge:Long_Integer;VAR SPR:SpriteDat):
          Long_Integer;GEMDOS($3F);
FUNCTION  OPEN_File(VAR Name:String;Atr:Integer):Integer;External;
 (* ffnet File        *)
PROCEDURE FCLOSE(handle:Integer);Gemdos($3E);
PROCEDURE PAUSE(I:Long_Integer);External;
 (* Wartet I/200 Sekunden *)
PROCEDURE RIGHT_L(VAR l:Long_Integer;Mode:Integer);External;
 (* Schiebt um 1 Bit nach rechts - Mode = 0: Bit #0 -> Bit #31 *)
PROCEDURE LEFT_L(VAR l:Long_Integer;Mode:Integer);External;
 (* Schiebt um 1 Bit nach links - Mode = 0: Bit #31 -> Bit #0 *)
PROCEDURE INC(VAR I:Integer);External;
 (* Erhht i um 1 *)
PROCEDURE NO_KEYPRESS;EXTERNAL;
 (* Lscht Tastatur-Puffer *)
PROCEDURE SHOWM;External;
PROCEDURE HIDEM;External;

PROCEDURE DEL_SPRITE(VAR Save:SpriteDat);External;
PROCEDURE SET_SPRITE(x,y:Long_Integer;VAR Sprite,Save:SpriteDat;
                     VAR Clipping:Clip);External;
PROCEDURE VBLS;XBIOS($25);
(* Wait for Vertical Blank *)

Begin
  HideM;
  write(#27,'f');              (* Cursor Off - Falls TOS Anwendung *)
  s0:='MUSTER';B:=True;
  For i:=0 to 2 do Begin
      s:=Concat(s0,chr(i+48),'.SPR');
      Handle:=Open_File(s,0);
      If Handle>0 then
         B:=B AND (Read_Muster(handle,128,Pattern[i])=128) else B:=False;
      FClose(handle);
  End;
  s:='SPRITE.SPR';
  Handle:=Open_File(s,0);
  If Handle>0 then
     B:=B AND (Read_Sprite(handle,264,Sprite)=264) else B:=False;
  FClose(handle);
  No_Keypress;
  Clipping[0]:=0;
  Clipping[1]:=64;
  Clipping[2]:=640;
  Clipping[3]:=336;
  If B then Begin
     Effectfill(0,400,32,Pattern[0]);Pause(200);
     Pattern[3]:=Pattern[0];
     Pattern[5]:=Pattern[0];
     Repeat
       Inc(i);
       For ii:=0 to 31 do Left_L(Pattern[0,ii],0);
       Fillscreen(0,400,32,Pattern[0]);
     Until Keypress;
     No_Keypress;
     Repeat
       Inc(i);
       For ii:=0 to (i mod 32) do Right_L(Pattern[0,ii],0);
       Fillscreen(0,400,32,Pattern[0]);
     Until Keypress;
     No_Keypress;
     Repeat
       FOR I:=0 TO 32 DO Begin
           Fillscreen(0,400,i mod 33,Pattern[1]);Pause(Pause1);
           Fillscreen(0,400,i mod 33,Pattern[2]);Pause(Pause1);
       End;
       for i:=Pause1 downto 0 do Begin
           Fillscreen(0,400,32,Pattern[1]);Pause(i);
           Fillscreen(0,400,32,Pattern[2]);Pause(i);
       End;
       For k:=0 to 31 do Begin
           For ii:=0 to 31 do Begin
               Right_L(Pattern[1,ii],0);
               Left_L(Pattern[2,ii],0);End;
           For ii:=0 to 31 do
               Pattern[4,ii]:=Pattern[1,ii]|Pattern[2,ii];
           Fillscreen(0,400,32,Pattern[4]);Pause(5);
       End;
       FOR I:=32 DOWNTO 0 DO Begin
           Fillscreen(0,400,i mod 33,Pattern[1]);Pause(20);
           Fillscreen(0,400,i mod 33,Pattern[2]);Pause(20);
       End;
     Until Keypress;
     No_Keypress;
     Effectfill(0,400,0,Pattern[0]);
     i:=0;
     Repeat
       For i:=1 to 32 do
           Fillscreen(0,400,i,Pattern[3]);
       For i:=0 to 31 do Begin
           For ii:=0 to 15 do Begin
               Right_L(Pattern[3,2*ii],0);
               Left_L(Pattern[3,1+2*ii],0);End;
           Fillscreen(0,400,32,Pattern[3]);
       End;
       Pause(200);
       For i:=32 downto 1 do
           Fillscreen(0,400,i,Pattern[3]);
     Until KeyPress;
       For i:=0 to 31 do Begin
           For ii:=0 to 15 do Begin
               Right_L(Pattern[3,2*ii],1);
               Left_L(Pattern[3,1+2*ii],1);End;
           Pause(10);
           Fillscreen(0,400,i,Pattern[3]);
       End;
     No_Keypress;
     Effectfill(0,400,32,Pattern[5]);
     Effectfill(Clipping[1],Clipping[3]-1,0,Pattern[5]);
     dx:=1;dy:=1;
     x:=80;y:=80;
     Repeat
       x:=x+dx;y:=y+dy;
       if x<1 then dx:=1;
       if x>638 then dx:=-1;
       if y>=Clipping[3] then dy:=-1;
       if y<=Clipping[1] then dy:=1;
       Set_Sprite(x,y,Sprite,Save,Clipping);
       VBLS;
       Del_Sprite(Save);
     Until Keypress;
     No_Keypress;ShowM;
  End;
End.
